--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

AutoRep = {};
AutoRep.lastupdate = 0;
AutoRep.lastamount = 0;

local InkedBackDropNFO =
	{
		bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Buttons\\WHITE8x8",
		tile = true,
		tileEdge = true,
		tileSize = 8,
		edgeSize = 1,
		insets = { left = 0, right = 0, top = 0, bottom =0 },
		
	}
function truncate(number, decimals)
    return number - (number % (0.1 ^ decimals))
end
local REPMover = CreateFrame("Frame","InkedRepBarDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	REPMover:SetSize(350,20)
	REPMover:SetFrameLevel(98)
	REPMover:SetClampedToScreen(true)
	REPMover:SetClampRectInsets(0, 0, 0,0)
	
	local REPMoverText  = REPMover:CreateFontString(nil, "OVERLAY")
	REPMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	REPMoverText:SetPoint("CENTER",REPMover,"CENTER", 0,0); 
	REPMoverText:SetText("")
	
	local InkedREPBar = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	InkedREPBar:SetAllPoints(REPMover)
	
	local Repframe = CreateFrame("Frame", nil, InkedREPBar, BackdropTemplateMixin and "BackdropTemplate")
	Repframe:SetAllPoints(InkedREPBar)
	Repframe:EnableMouse(true)
	
	Repframe.bar = CreateFrame("StatusBar", nil, Repframe, BackdropTemplateMixin and "BackdropTemplate")
	Repframe.bar:SetPoint("TOPLEFT",2, -3)
	--Repframe.bar:SetPoint("TOPRIGHT", 0, 0)
	--Repframe.bar:SetSize(346,19)
	Repframe.bar:SetFrameLevel(6)
	
	local REPText = Repframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			REPText:SetPoint("CENTER", 0, -1)
			REPText:SetJustifyH("CENTER")
			REPText:SetJustifyV("CENTER")

	local REPMaxText = Repframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			REPMaxText:SetPoint("RIGHT", -2, -1)
			REPMaxText:SetJustifyH("RIGHT")
			REPMaxText:SetJustifyV("CENTER")

	local RepCurrentText = Repframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			RepCurrentText:SetPoint("LEFT", 2, -1)
			RepCurrentText:SetJustifyH("LEFT")
			RepCurrentText:SetJustifyV("CENTER")
	
local function UpdateMe()
		if(Inked.db.profile.lockframes == false) then
			if Inked.db.profile.RepEnable == true then
				local point, relativeTo, relativePoint, xOfs, yOfs = REPMover:GetPoint(n)
				Inked.db.profile.RepX = xOfs
				Inked.db.profile.RepY = yOfs
				Inked.db.profile.RepPoint = point
				REPMoverText:SetText("REP BAR")
			end
		end	
		if Inked.db.profile.RepEnable == true then
			REPMover:SetSize(Inked.db.profile.RepWidth,Inked.db.profile.RepHeight)
			Repframe.bar:SetSize(Inked.db.profile.RepWidth-4,Inked.db.profile.RepHeight-5)
			
			REPText:SetFont(LSM:Fetch("font", Inked.db.profile.Repfont), Inked.db.profile.RepFontSize, Inked.db.profile.RepFontOutline)
			REPMaxText:SetFont(LSM:Fetch("font", Inked.db.profile.Repfont), Inked.db.profile.RepFontSize, Inked.db.profile.RepFontOutline)
			RepCurrentText:SetFont(LSM:Fetch("font", Inked.db.profile.Repfont), Inked.db.profile.RepFontSize, Inked.db.profile.RepFontOutline)
			Repframe.bar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.RepStatusBar))
			local name, standing, min, max, value, factionID = GetWatchedFactionInfo()
			--value = 3000
			if standing == 1 then
				Repframe.bar:SetStatusBarColor(1,0.1,0.1)			
			end
			if standing == 2 then
				Repframe.bar:SetStatusBarColor(1,0.5,0.25)
			end
			if standing == 3 then
				Repframe.bar:SetStatusBarColor(1,0.7,0.3)
			end
			if standing == 4 then
				Repframe.bar:SetStatusBarColor(1,1,0)
			end
			if standing == 5 then
				Repframe.bar:SetStatusBarColor(0.32,0.67,0)
			end
			if standing == 6 then
				Repframe.bar:SetStatusBarColor(0,0.44,1)
			end
			if standing == 7 then
				Repframe.bar:SetStatusBarColor(0.64,0.21,0.93)
			end
			if standing == 8 then
				Repframe.bar:SetStatusBarColor(0.9,0.8,0.5)
			end
			if factionID and C_Reputation.IsFactionParagon(factionID) then
			 local currentValue, threshold, rewardQuestID, hasRewardPending, tooLowLevelForParagon = C_Reputation.GetFactionParagonInfo(factionID)
				local ParaMax = threshold
				local ParaCurrent = currentValue
				local doodley = 0
				for i = 1,9999 do 				
					if ParaCurrent > (ParaMax * doodley) then
						doodley = doodley + 1
					end
				end
				ParaCurrent = currentValue - (ParaMax * doodley) + threshold					
				Repframe.bar:SetMinMaxValues(1, threshold)
				Repframe.bar:SetValue(ParaCurrent)
					REPText:SetText(name)
						if ParaCurrent > 1000 then
							RepCurrentText:SetText(truncate(ParaCurrent/1000,1).."K")
						else
							RepCurrentText:SetText(ParaCurrent)
						end	
						if threshold > 1000 then
							REPMaxText:SetText(truncate(threshold/1000,1).."K")
						else
							REPMaxText:SetText(threshold)
						end
				else 
			--	currentRep = value-min
				MaxRep = max-min
				MinRep = min - min
				Repframe.bar:SetMinMaxValues(MinRep, MaxRep)
				Repframe.bar:SetValue(currentRep)
						if currentRep > 1000 then
						RepCurrentText:SetText(truncate(currentRep/1000,1).."K")
						else
						RepCurrentText:SetText(currentRep)
						end
						if MaxRep > 1000 then
						REPMaxText:SetText(truncate(MaxRep/1000,1).."K")
						else
						REPMaxText:SetText(MaxRep)
						end
					REPText:SetText(name)
			end
		end
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)
	
local function CreateButtonTexture(frame)
	local ButtonForground = CreateFrame("Frame","Foreground",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForground:SetAllPoints(frame)
		  ButtonForground:SetFrameLevel(4)
	local ButtonTexture = ButtonForground:CreateTexture(nil, "BACKGROUND")
		  ButtonTexture:SetAllPoints()
		  ButtonTexture:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		  ButtonTexture:SetTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\PsychoButton")

end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end


local function SetRepBar()
	if Inked.db.profile.RepEnable == true then
		Repframe.bar:SetBackdrop(InkedBackDropNFO)
		Repframe.bar:SetBackdropColor(0,0,0,0.5)
		Repframe.bar:SetBackdropBorderColor(0,0,0,0.5)
	end
	if(Inked.db.profile.lockframes == false) then
			REPMover:ClearAllPoints()
			if Inked.db.profile.RepPoint == nil then
				REPMover:SetPoint("TOP", UIParent,Inked.db.profile.RepX,Inked.db.profile.RepY)
			else
				REPMover:SetPoint(Inked.db.profile.RepPoint, UIParent,Inked.db.profile.RepX,Inked.db.profile.RepY)
			end
			if Inked.db.profile.RepEnable == true then
				REPMover:SetBackdrop(InkedBackDropNFO) 
				REPMover:SetBackdropColor(0,0.55,0.95,0.45)
				REPMover:SetBackdropBorderColor(0,0.55,0.95,0)
				REPMover:SetMovable(true)
				REPMover:EnableMouse(true)
				REPMover:RegisterForDrag("LeftButton")
				REPMover:SetScript("OnDragStart", REPMover.StartMoving)
				REPMover:SetScript("OnDragStop", REPMover.StopMovingOrSizing)
				REPMover:SetUserPlaced(true)
			end
		elseif Inked.db.profile.RepPoint == nil then
				REPMover:SetPoint("TOP", UIParent,Inked.db.profile.RepX,Inked.db.profile.RepY)
			else
				REPMover:SetPoint(Inked.db.profile.RepPoint, UIParent,Inked.db.profile.RepX,Inked.db.profile.RepY)
		end
end
local function walkingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == false) then
		--InkedREPBar:Show()
		--print("walking")
	end
end
local function ridingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == true) then
		--InkedREPBar:Hide()
	end
end
local function StartBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
	if(inBattle == true) then	
		InkedREPBar:Hide()
	end
end
local function EndBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
--print(inBattle)
	if(inBattle == false) then
		InkedREPBar:Show()		
	end
end
	local InkedLoginFrame=CreateFrame("Frame") -- Create the Frame
	InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")--Register the Player Login event
	InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
	InkedLoginFrame:RegisterEvent("PET_BATTLE_OPENING_START")
	InkedLoginFrame:RegisterEvent("PET_BATTLE_CLOSE")
	InkedLoginFrame:RegisterEvent("UNIT_EXITED_VEHICLE")
	InkedLoginFrame:RegisterEvent("UNIT_ENTERED_VEHICLE")
	InkedLoginFrame:SetScript("OnEvent", function(self, event) -- create the event script	
		if Inked.db.profile.UseActionBars == false then return end
		if Inked.db.profile.RepEnable == false then return end
			SetRepBar()
			StartBattlePetsFun()
			EndBattlePetsFun()
			ridingFun()
			walkingFun()
		end)
		
local function OnEvent(self)			
		local name, standing, min, max, value, factionID = GetWatchedFactionInfo()
		currentRep = value-min
		MaxRep = max-min
		MinRep = min - min
				
		-- Setup
				if name == nil then
					Repframe:Hide()	
				elseif currentRep > 0 then
					Repframe:Show()
				end
				
		self:SetScript("OnEnter", function()
			
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 0, -10)
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
			GameTooltip:ClearLines()
			GameTooltip:AddDoubleLine(name)
			GameTooltip:AddLine(" ")
			local myStanding = "" 
			if standing == 1 then
				myStanding = "Hated"
			end
			if standing == 2 then
				myStanding = "Hostile"
			end
			if standing == 3 then
				myStanding = "Unfriendly"
			end
			if standing == 4 then
				myStanding = "Nuetral"
			end
			if standing == 5 then
				myStanding = "Friendly"
			end
			if standing == 6 then
				myStanding = "Honored"
			end
			if standing == 7 then
				myStanding = "Revered"
			end
			if standing == 8 then
				myStanding = "Exalted"
			end
		
			if factionID and C_Reputation.IsFactionParagon(factionID) then
				if standing == 8 then
					Repframe.bar:SetStatusBarColor(0.95,0.85,0.55)
					Repframe:SetBeautyBorderColor(0.95,0.85,0.55,0.75)
				end
			 local currentValue, threshold, rewardQuestID, hasRewardPending, tooLowLevelForParagon = C_Reputation.GetFactionParagonInfo(factionID)


				local ParaMax = threshold
				local ParaCurrent = currentValue
				local doodley = 0
				for i = 1,9999 do 
				
					if ParaCurrent > (ParaMax * doodley) then
						doodley = doodley + 1
					end
				end
					ParaCurrent = currentValue - (ParaMax * doodley) + threshold
					--next i

				GameTooltip:AddDoubleLine("Paragon")
				GameTooltip:AddLine(" ")
				GameTooltip:AddDoubleLine(ParaCurrent .. " / " .. ParaMax)
				else 
				GameTooltip:AddDoubleLine(myStanding)
				GameTooltip:AddLine(" ")
				GameTooltip:AddDoubleLine(currentRep .." / " .. MaxRep)
			end

			GameTooltip:Show()
		end)
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
	end
	
		Repframe:SetScript("OnMouseDown", function(self, button)
		if button == "RightButton" then
			
			self:GetScript("OnEnter")(self)
		else
			ToggleCharacter("ReputationFrame")
		end
	end)

Repframe:SetScript("OnEvent", OnEvent)
Repframe:HookScript("OnUpdate", UpdateMe)
Repframe:RegisterEvent("UPDATE_FACTION")
		---Auto Rep Switch --
function AutoRep.OnEvent(_, event, arg1)
	if(event == "COMBAT_TEXT_UPDATE" and arg1 == "FACTION") then
			local faction, amount = GetCurrentCombatTextEventInfo()

			if (faction ~= "Guild") then
				if (amount > AutoRep.lastamount) or (time() > AutoRep.lastupdate) then
					for i=1,GetNumFactions() do
						if faction == GetFactionInfo(i) then
						
							SetWatchedFactionIndex(i);
						end
					end
				end
				AutoRep.lastamount = amount;
				AutoRep.lastupdate = time();
			end
		
	end
end

AutoRep.frame = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate");
AutoRep.frame:RegisterEvent("COMBAT_TEXT_UPDATE");
AutoRep.frame:SetScript("OnEvent", AutoRep.OnEvent);
