--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

	local BagBarMover = CreateFrame("Frame","InkedBAGBarDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	BagBarMover:SetSize(160,32)
	BagBarMover:SetFrameLevel(98)
	BagBarMover:SetClampedToScreen(true)
	BagBarMover:SetClampRectInsets(0, 0, 0,0)
	
	local BagBarMoverText  = BagBarMover:CreateFontString(nil, "OVERLAY")
	BagBarMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	BagBarMoverText:SetPoint("CENTER",BagBarMover,"CENTER", 0,0); 
	BagBarMoverText:SetText("")
	
	local function UpdateMe()
		if(Inked.db.profile.lockframes == false) then
			local point, relativeTo, relativePoint, xOfs, yOfs = BagBarMover:GetPoint(n)
			Inked.db.profile.BagBarX = xOfs
			Inked.db.profile.BagBarY = yOfs
			Inked.db.profile.BagBarPoint = point
			BagBarMoverText:SetText("Bag Bar")
		end	
		
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)
	
local function CreateButtonTexture(frame)
	local ButtonForground = CreateFrame("Frame","Foreground",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForground:SetAllPoints(frame)
		  ButtonForground:SetFrameLevel(4)
	local ButtonTexture = ButtonForground:CreateTexture(nil, "BACKGROUND")
		  ButtonTexture:SetAllPoints()
		  ButtonTexture:SetTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		
				if Inked.db.profile.ClassBagBarColor == true then
						ButtonTexture:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
					elseif Inked.db.profile.ClassBagBarColor == false then
						if Inked.db.profile.CustomBagBarColor == true then
							ButtonTexture:SetVertexColor(Inked.db.profile.BagBarColorR,Inked.db.profile.BagBarColorG,Inked.db.profile.BagBarColorB,Inked.db.profile.BagBarColorA)
						elseif Inked.db.profile.CustomBagBarColor == false then
							ButtonTexture:SetVertexColor(1,1,1,1)
						end
					end
		  
			
		
end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local InkedBagBar = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
InkedBagBar:SetAllPoints(BagBarMover)


local function SetBags()
	if Inked.db.profile.BagBarShow == true then
		MainMenuBarBackpackButton:Show()
		CharacterBag0Slot:SetAlpha(1)
		CharacterBag1Slot:SetAlpha(1)
		CharacterBag2Slot:SetAlpha(1)
		CharacterBag3Slot:SetAlpha(1)
		if Inked.db.profile.BagBarShowOnlyMainBag == true then
			--print("Backpack")
			CharacterBag0Slot:Hide()
			CharacterBag1Slot:Hide()
			CharacterBag2Slot:Hide()
			CharacterBag3Slot:Hide()
		end
	
	elseif Inked.db.profile.BagBarShow == false then
		MainMenuBarBackpackButton:Hide()
		CharacterBag0Slot:SetAlpha(0)
		CharacterBag1Slot:SetAlpha(0)
		CharacterBag2Slot:SetAlpha(0)
		CharacterBag3Slot:SetAlpha(0)
	end
	
	MainMenuBarBackpackButton:SetParent(InkedBagBar)
	MainMenuBarBackpackButton:ClearAllPoints();
	MainMenuBarBackpackButton:SetScale(0.85)
	MainMenuBarBackpackButton:SetPoint("LEFT", InkedBagBar,0,0);
	CreateButtonTexture(MainMenuBarBackpackButton)
	CharacterBag0Slot:SetParent(MainMenuBarBackpackButton)
	CharacterBag0Slot:ClearAllPoints();
	CharacterBag0Slot:SetPoint("CENTER", MainMenuBarBackpackButton, "CENTER",41, -3);
	CreateButtonTexture(CharacterBag0Slot)
	CharacterBag1Slot:SetParent(MainMenuBarBackpackButton)
	CharacterBag1Slot:ClearAllPoints();
	CharacterBag1Slot:SetPoint("CENTER", CharacterBag0Slot, "CENTER",35, 0);
	CreateButtonTexture(CharacterBag1Slot)
	CharacterBag2Slot:SetParent(MainMenuBarBackpackButton)
	CharacterBag2Slot:ClearAllPoints();
	CharacterBag2Slot:SetPoint("CENTER", CharacterBag1Slot, "CENTER",35, 0);
	CreateButtonTexture(CharacterBag2Slot)
	CharacterBag3Slot:SetParent(MainMenuBarBackpackButton)
	CharacterBag3Slot:ClearAllPoints();
	CharacterBag3Slot:SetPoint("CENTER", CharacterBag2Slot, "CENTER",35, 0);
	CreateButtonTexture(CharacterBag3Slot)


	if(Inked.db.profile.lockframes == false) then
			BagBarMover:ClearAllPoints()
			if Inked.db.profile.BagBarPoint == nil then
				BagBarMover:SetPoint("BOTTOMRIGHT", UIParent,Inked.db.profile.BagBarX,Inked.db.profile.BagBarY)
			else
				BagBarMover:SetPoint(Inked.db.profile.BagBarPoint, UIParent,Inked.db.profile.BagBarX,Inked.db.profile.BagBarY)
			end
			CreateMoverBackdrop(BagBarMover)
			BagBarMover:SetMovable(true)
			BagBarMover:EnableMouse(true)
			BagBarMover:RegisterForDrag("LeftButton")
			BagBarMover:SetScript("OnDragStart", BagBarMover.StartMoving)
			BagBarMover:SetScript("OnDragStop", BagBarMover.StopMovingOrSizing)
			BagBarMover:SetUserPlaced(true)
		elseif Inked.db.profile.BagBarPoint == nil then
				BagBarMover:SetPoint("BOTTOMRIGHT", UIParent,Inked.db.profile.BagBarX,Inked.db.profile.BagBarY)
			else
				BagBarMover:SetPoint(Inked.db.profile.BagBarPoint, UIParent,Inked.db.profile.BagBarX,Inked.db.profile.BagBarY)
		end
end
local function walkingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == false) then
		if Inked.db.profile.BagBarShow == true then
			MainMenuBarBackpackButton:Show()
			CharacterBag0Slot:SetAlpha(1)
			CharacterBag1Slot:SetAlpha(1)
			CharacterBag2Slot:SetAlpha(1)
			CharacterBag3Slot:SetAlpha(1)
			if Inked.db.profile.BagBarShowOnlyMainBag == true then
				CharacterBag0Slot:SetAlpha(0)
				CharacterBag1Slot:SetAlpha(0)
				CharacterBag2Slot:SetAlpha(0)
				CharacterBag3Slot:SetAlpha(0)
			end
		end
	end
end
local function ridingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == true) then
		MainMenuBarBackpackButton:Hide()
		CharacterBag0Slot:SetAlpha(0)
		CharacterBag1Slot:SetAlpha(0)
		CharacterBag2Slot:SetAlpha(0)
		CharacterBag3Slot:SetAlpha(0)
	end
end
local function StartBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()

	if(inBattle == true) then
		MainMenuBarBackpackButton:SetScale(0.0001)
		CharacterBag0Slot:Hide()
		CharacterBag1Slot:Hide()
		CharacterBag2Slot:Hide()
		CharacterBag3Slot:Hide()

	end
end
local function EndBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()

	if(inBattle == false) then
		if Inked.db.profile.BagBarShow == true then
			MainMenuBarBackpackButton:SetScale(0.85)
			CharacterBag0Slot:Show()
			CharacterBag1Slot:Show()
			CharacterBag2Slot:Show()
			CharacterBag3Slot:Show()
		end
			if Inked.db.profile.BagBarShowOnlyMainBag == true then
				CharacterBag0Slot:Hide()
				CharacterBag1Slot:Hide()
				CharacterBag2Slot:Hide()
				CharacterBag3Slot:Hide()
			end

	end
end

local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:RegisterEvent("PET_BATTLE_OPENING_START")
		InkedLoginFrame:RegisterEvent("PET_BATTLE_CLOSE")
		InkedLoginFrame:RegisterEvent("UNIT_EXITED_VEHICLE")
		InkedLoginFrame:RegisterEvent("UNIT_ENTERED_VEHICLE")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
		if Inked.db.profile.UseBagBar == false then return end  
		if Inked.db.profile.UseActionBars == false then return end
			SetBags()
			StartBattlePetsFun()
			EndBattlePetsFun()
			ridingFun()
			walkingFun()
												
		end)